<?php

/**
 * Base static class for performing query and update operations on the 'katao_order' table.
 *
 * 
 *
 * @package    lib.model.om
 */
abstract class BaseKataoOrderPeer {

	/** the default database name for this class */
	const DATABASE_NAME = 'propel';

	/** the table name for this class */
	const TABLE_NAME = 'katao_order';

	/** A class that can be returned by this peer. */
	const CLASS_DEFAULT = 'lib.model.KataoOrder';

	/** The total number of columns. */
	const NUM_COLUMNS = 20;

	/** The number of lazy-loaded columns. */
	const NUM_LAZY_LOAD_COLUMNS = 0;


	/** the column name for the ID field */
	const ID = 'katao_order.ID';

	/** the column name for the KATAO_SUPPLIER_ID field */
	const KATAO_SUPPLIER_ID = 'katao_order.KATAO_SUPPLIER_ID';

	/** the column name for the KATAO_PERIOD_ID field */
	const KATAO_PERIOD_ID = 'katao_order.KATAO_PERIOD_ID';

	/** the column name for the KATAO_NODE_ID field */
	const KATAO_NODE_ID = 'katao_order.KATAO_NODE_ID';

	/** the column name for the STATUS field */
	const STATUS = 'katao_order.STATUS';

	/** the column name for the IS_SIMULATED field */
	const IS_SIMULATED = 'katao_order.IS_SIMULATED';

	/** the column name for the SUPPLIER_NAME field */
	const SUPPLIER_NAME = 'katao_order.SUPPLIER_NAME';

	/** the column name for the SUPPLIER_EMAIL field */
	const SUPPLIER_EMAIL = 'katao_order.SUPPLIER_EMAIL';

	/** the column name for the SUPPLIER_ADDRESS1 field */
	const SUPPLIER_ADDRESS1 = 'katao_order.SUPPLIER_ADDRESS1';

	/** the column name for the SUPPLIER_ADDRESS2 field */
	const SUPPLIER_ADDRESS2 = 'katao_order.SUPPLIER_ADDRESS2';

	/** the column name for the SUPPLIER_ZIP field */
	const SUPPLIER_ZIP = 'katao_order.SUPPLIER_ZIP';

	/** the column name for the SUPPLIER_CITY field */
	const SUPPLIER_CITY = 'katao_order.SUPPLIER_CITY';

	/** the column name for the KATAO_NAME field */
	const KATAO_NAME = 'katao_order.KATAO_NAME';

	/** the column name for the KATAO_ADDRESS field */
	const KATAO_ADDRESS = 'katao_order.KATAO_ADDRESS';

	/** the column name for the KATAO_SIRET_NUMBER field */
	const KATAO_SIRET_NUMBER = 'katao_order.KATAO_SIRET_NUMBER';

	/** the column name for the KATAO_RCS_NUMBER field */
	const KATAO_RCS_NUMBER = 'katao_order.KATAO_RCS_NUMBER';

	/** the column name for the KATAO_CAPITAL field */
	const KATAO_CAPITAL = 'katao_order.KATAO_CAPITAL';

	/** the column name for the DELIVERY_ADDRESS field */
	const DELIVERY_ADDRESS = 'katao_order.DELIVERY_ADDRESS';

	/** the column name for the CREATED_AT field */
	const CREATED_AT = 'katao_order.CREATED_AT';

	/** the column name for the UPDATED_AT field */
	const UPDATED_AT = 'katao_order.UPDATED_AT';

	/** The PHP to DB Name Mapping */
	private static $phpNameMap = null;


	/**
	 * holds an array of fieldnames
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
	 */
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('Id', 'KataoSupplierId', 'KataoPeriodId', 'KataoNodeId', 'Status', 'IsSimulated', 'SupplierName', 'SupplierEmail', 'SupplierAddress1', 'SupplierAddress2', 'SupplierZip', 'SupplierCity', 'KataoName', 'KataoAddress', 'KataoSiretNumber', 'KataoRcsNumber', 'KataoCapital', 'DeliveryAddress', 'CreatedAt', 'UpdatedAt', ),
		BasePeer::TYPE_COLNAME => array (KataoOrderPeer::ID, KataoOrderPeer::KATAO_SUPPLIER_ID, KataoOrderPeer::KATAO_PERIOD_ID, KataoOrderPeer::KATAO_NODE_ID, KataoOrderPeer::STATUS, KataoOrderPeer::IS_SIMULATED, KataoOrderPeer::SUPPLIER_NAME, KataoOrderPeer::SUPPLIER_EMAIL, KataoOrderPeer::SUPPLIER_ADDRESS1, KataoOrderPeer::SUPPLIER_ADDRESS2, KataoOrderPeer::SUPPLIER_ZIP, KataoOrderPeer::SUPPLIER_CITY, KataoOrderPeer::KATAO_NAME, KataoOrderPeer::KATAO_ADDRESS, KataoOrderPeer::KATAO_SIRET_NUMBER, KataoOrderPeer::KATAO_RCS_NUMBER, KataoOrderPeer::KATAO_CAPITAL, KataoOrderPeer::DELIVERY_ADDRESS, KataoOrderPeer::CREATED_AT, KataoOrderPeer::UPDATED_AT, ),
		BasePeer::TYPE_FIELDNAME => array ('id', 'katao_supplier_id', 'katao_period_id', 'katao_node_id', 'status', 'is_simulated', 'supplier_name', 'supplier_email', 'supplier_address1', 'supplier_address2', 'supplier_zip', 'supplier_city', 'katao_name', 'katao_address', 'katao_siret_number', 'katao_rcs_number', 'katao_capital', 'delivery_address', 'created_at', 'updated_at', ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, )
	);

	/**
	 * holds an array of keys for quick access to the fieldnames array
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[BasePeer::TYPE_PHPNAME]['Id'] = 0
	 */
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'KataoSupplierId' => 1, 'KataoPeriodId' => 2, 'KataoNodeId' => 3, 'Status' => 4, 'IsSimulated' => 5, 'SupplierName' => 6, 'SupplierEmail' => 7, 'SupplierAddress1' => 8, 'SupplierAddress2' => 9, 'SupplierZip' => 10, 'SupplierCity' => 11, 'KataoName' => 12, 'KataoAddress' => 13, 'KataoSiretNumber' => 14, 'KataoRcsNumber' => 15, 'KataoCapital' => 16, 'DeliveryAddress' => 17, 'CreatedAt' => 18, 'UpdatedAt' => 19, ),
		BasePeer::TYPE_COLNAME => array (KataoOrderPeer::ID => 0, KataoOrderPeer::KATAO_SUPPLIER_ID => 1, KataoOrderPeer::KATAO_PERIOD_ID => 2, KataoOrderPeer::KATAO_NODE_ID => 3, KataoOrderPeer::STATUS => 4, KataoOrderPeer::IS_SIMULATED => 5, KataoOrderPeer::SUPPLIER_NAME => 6, KataoOrderPeer::SUPPLIER_EMAIL => 7, KataoOrderPeer::SUPPLIER_ADDRESS1 => 8, KataoOrderPeer::SUPPLIER_ADDRESS2 => 9, KataoOrderPeer::SUPPLIER_ZIP => 10, KataoOrderPeer::SUPPLIER_CITY => 11, KataoOrderPeer::KATAO_NAME => 12, KataoOrderPeer::KATAO_ADDRESS => 13, KataoOrderPeer::KATAO_SIRET_NUMBER => 14, KataoOrderPeer::KATAO_RCS_NUMBER => 15, KataoOrderPeer::KATAO_CAPITAL => 16, KataoOrderPeer::DELIVERY_ADDRESS => 17, KataoOrderPeer::CREATED_AT => 18, KataoOrderPeer::UPDATED_AT => 19, ),
		BasePeer::TYPE_FIELDNAME => array ('id' => 0, 'katao_supplier_id' => 1, 'katao_period_id' => 2, 'katao_node_id' => 3, 'status' => 4, 'is_simulated' => 5, 'supplier_name' => 6, 'supplier_email' => 7, 'supplier_address1' => 8, 'supplier_address2' => 9, 'supplier_zip' => 10, 'supplier_city' => 11, 'katao_name' => 12, 'katao_address' => 13, 'katao_siret_number' => 14, 'katao_rcs_number' => 15, 'katao_capital' => 16, 'delivery_address' => 17, 'created_at' => 18, 'updated_at' => 19, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, )
	);

	/**
	 * @return     MapBuilder the map builder for this peer
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function getMapBuilder()
	{
		return BasePeer::getMapBuilder('lib.model.map.KataoOrderMapBuilder');
	}
	/**
	 * Gets a map (hash) of PHP names to DB column names.
	 *
	 * @return     array The PHP to DB name map for this peer
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 * @deprecated Use the getFieldNames() and translateFieldName() methods instead of this.
	 */
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = KataoOrderPeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	/**
	 * Translates a fieldname to another type
	 *
	 * @param      string $name field name
	 * @param      string $fromType One of the class type constants TYPE_PHPNAME,
	 *                         TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @param      string $toType   One of the class type constants
	 * @return     string translated name of the field.
	 */
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	/**
	 * Returns an array of of field names.
	 *
	 * @param      string $type The type of fieldnames to return:
	 *                      One of the class type constants TYPE_PHPNAME,
	 *                      TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     array A list of field names
	 */

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	/**
	 * Convenience method which changes table.column to alias.column.
	 *
	 * Using this method you can maintain SQL abstraction while using column aliases.
	 * <code>
	 *		$c->addAlias("alias1", TablePeer::TABLE_NAME);
	 *		$c->addJoin(TablePeer::alias("alias1", TablePeer::PRIMARY_KEY_COLUMN), TablePeer::PRIMARY_KEY_COLUMN);
	 * </code>
	 * @param      string $alias The alias for the current table.
	 * @param      string $column The column name for current table. (i.e. KataoOrderPeer::COLUMN_NAME).
	 * @return     string
	 */
	public static function alias($alias, $column)
	{
		return str_replace(KataoOrderPeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	/**
	 * Add all the columns needed to create a new object.
	 *
	 * Note: any columns that were marked with lazyLoad="true" in the
	 * XML schema will not be added to the select list and only loaded
	 * on demand.
	 *
	 * @param      criteria object containing the columns to add.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(KataoOrderPeer::ID);

		$criteria->addSelectColumn(KataoOrderPeer::KATAO_SUPPLIER_ID);

		$criteria->addSelectColumn(KataoOrderPeer::KATAO_PERIOD_ID);

		$criteria->addSelectColumn(KataoOrderPeer::KATAO_NODE_ID);

		$criteria->addSelectColumn(KataoOrderPeer::STATUS);

		$criteria->addSelectColumn(KataoOrderPeer::IS_SIMULATED);

		$criteria->addSelectColumn(KataoOrderPeer::SUPPLIER_NAME);

		$criteria->addSelectColumn(KataoOrderPeer::SUPPLIER_EMAIL);

		$criteria->addSelectColumn(KataoOrderPeer::SUPPLIER_ADDRESS1);

		$criteria->addSelectColumn(KataoOrderPeer::SUPPLIER_ADDRESS2);

		$criteria->addSelectColumn(KataoOrderPeer::SUPPLIER_ZIP);

		$criteria->addSelectColumn(KataoOrderPeer::SUPPLIER_CITY);

		$criteria->addSelectColumn(KataoOrderPeer::KATAO_NAME);

		$criteria->addSelectColumn(KataoOrderPeer::KATAO_ADDRESS);

		$criteria->addSelectColumn(KataoOrderPeer::KATAO_SIRET_NUMBER);

		$criteria->addSelectColumn(KataoOrderPeer::KATAO_RCS_NUMBER);

		$criteria->addSelectColumn(KataoOrderPeer::KATAO_CAPITAL);

		$criteria->addSelectColumn(KataoOrderPeer::DELIVERY_ADDRESS);

		$criteria->addSelectColumn(KataoOrderPeer::CREATED_AT);

		$criteria->addSelectColumn(KataoOrderPeer::UPDATED_AT);

	}

	const COUNT = 'COUNT(katao_order.ID)';
	const COUNT_DISTINCT = 'COUNT(DISTINCT katao_order.ID)';

	/**
	 * Returns the number of rows matching criteria.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$rs = KataoOrderPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}
	/**
	 * Method to select one object from the DB.
	 *
	 * @param      Criteria $criteria object used to create the SELECT statement.
	 * @param      Connection $con
	 * @return     KataoOrder
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = KataoOrderPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	/**
	 * Method to do selects.
	 *
	 * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
	 * @param      Connection $con
	 * @return     array Array of selected Objects
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return KataoOrderPeer::populateObjects(KataoOrderPeer::doSelectRS($criteria, $con));
	}
	/**
	 * Prepares the Criteria object and uses the parent doSelect()
	 * method to get a ResultSet.
	 *
	 * Use this method directly if you want to just get the resultset
	 * (instead of an array of objects).
	 *
	 * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
	 * @param      Connection $con the connection to use
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 * @return     ResultSet The resultset object with numerically-indexed fields.
	 * @see        BasePeer::doSelect()
	 */
	public static function doSelectRS(Criteria $criteria, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoOrderPeer:doSelectRS:doSelectRS') as $callable)
    {
      call_user_func($callable, 'BaseKataoOrderPeer', $criteria, $con);
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if (!$criteria->getSelectColumns()) {
			$criteria = clone $criteria;
			KataoOrderPeer::addSelectColumns($criteria);
		}

		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);

		// BasePeer returns a Creole ResultSet, set to return
		// rows indexed numerically.
		return BasePeer::doSelect($criteria, $con);
	}
	/**
	 * The returned array will contain objects of the default type or
	 * objects that inherit from the default.
	 *
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
	
		// set the class once to avoid overhead in the loop
		$cls = KataoOrderPeer::getOMClass();
		$cls = sfPropel::import($cls);
		// populate the object(s)
		while($rs->next()) {
		
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
			
		}
		return $results;
	}

	/**
	 * Returns the number of rows matching criteria, joining the related KataoSupplier table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinKataoSupplier(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoOrderPeer::KATAO_SUPPLIER_ID, KataoSupplierPeer::ID);

		$rs = KataoOrderPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Returns the number of rows matching criteria, joining the related KataoPeriod table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinKataoPeriod(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoOrderPeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$rs = KataoOrderPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Returns the number of rows matching criteria, joining the related KataoNode table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinKataoNode(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoOrderPeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$rs = KataoOrderPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Selects a collection of KataoOrder objects pre-filled with their KataoSupplier objects.
	 *
	 * @return     array Array of KataoOrder objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinKataoSupplier(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoOrderPeer:doSelectJoin:doSelectJoin') as $callable)
    {
      call_user_func($callable, 'BaseKataoOrderPeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoOrderPeer::addSelectColumns($c);
		$startcol = (KataoOrderPeer::NUM_COLUMNS - KataoOrderPeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		KataoSupplierPeer::addSelectColumns($c);

		$c->addJoin(KataoOrderPeer::KATAO_SUPPLIER_ID, KataoSupplierPeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoOrderPeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoSupplierPeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getKataoSupplier(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					// e.g. $author->addBookRelatedByBookId()
					$temp_obj2->addKataoOrder($obj1); //CHECKME
					break;
				}
			}
			if ($newObject) {
				$obj2->initKataoOrders();
				$obj2->addKataoOrder($obj1); //CHECKME
			}
			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Selects a collection of KataoOrder objects pre-filled with their KataoPeriod objects.
	 *
	 * @return     array Array of KataoOrder objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinKataoPeriod(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoOrderPeer:doSelectJoin:doSelectJoin') as $callable)
    {
      call_user_func($callable, 'BaseKataoOrderPeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoOrderPeer::addSelectColumns($c);
		$startcol = (KataoOrderPeer::NUM_COLUMNS - KataoOrderPeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		KataoPeriodPeer::addSelectColumns($c);

		$c->addJoin(KataoOrderPeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoOrderPeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoPeriodPeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getKataoPeriod(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					// e.g. $author->addBookRelatedByBookId()
					$temp_obj2->addKataoOrder($obj1); //CHECKME
					break;
				}
			}
			if ($newObject) {
				$obj2->initKataoOrders();
				$obj2->addKataoOrder($obj1); //CHECKME
			}
			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Selects a collection of KataoOrder objects pre-filled with their KataoNode objects.
	 *
	 * @return     array Array of KataoOrder objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinKataoNode(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoOrderPeer:doSelectJoin:doSelectJoin') as $callable)
    {
      call_user_func($callable, 'BaseKataoOrderPeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoOrderPeer::addSelectColumns($c);
		$startcol = (KataoOrderPeer::NUM_COLUMNS - KataoOrderPeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		KataoNodePeer::addSelectColumns($c);

		$c->addJoin(KataoOrderPeer::KATAO_NODE_ID, KataoNodePeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoOrderPeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoNodePeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getKataoNode(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					// e.g. $author->addBookRelatedByBookId()
					$temp_obj2->addKataoOrder($obj1); //CHECKME
					break;
				}
			}
			if ($newObject) {
				$obj2->initKataoOrders();
				$obj2->addKataoOrder($obj1); //CHECKME
			}
			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Returns the number of rows matching criteria, joining all related tables
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinAll(Criteria $criteria, $distinct = false, $con = null)
	{
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoOrderPeer::KATAO_SUPPLIER_ID, KataoSupplierPeer::ID);

		$criteria->addJoin(KataoOrderPeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$criteria->addJoin(KataoOrderPeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$rs = KataoOrderPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Selects a collection of KataoOrder objects pre-filled with all related objects.
	 *
	 * @return     array Array of KataoOrder objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAll(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoOrderPeer:doSelectJoinAll:doSelectJoinAll') as $callable)
    {
      call_user_func($callable, 'BaseKataoOrderPeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoOrderPeer::addSelectColumns($c);
		$startcol2 = (KataoOrderPeer::NUM_COLUMNS - KataoOrderPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		KataoSupplierPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + KataoSupplierPeer::NUM_COLUMNS;

		KataoPeriodPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + KataoPeriodPeer::NUM_COLUMNS;

		KataoNodePeer::addSelectColumns($c);
		$startcol5 = $startcol4 + KataoNodePeer::NUM_COLUMNS;

		$c->addJoin(KataoOrderPeer::KATAO_SUPPLIER_ID, KataoSupplierPeer::ID);

		$c->addJoin(KataoOrderPeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$c->addJoin(KataoOrderPeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoOrderPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);


				// Add objects for joined KataoSupplier rows
	
			$omClass = KataoSupplierPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getKataoSupplier(); // CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addKataoOrder($obj1); // CHECKME
					break;
				}
			}

			if ($newObject) {
				$obj2->initKataoOrders();
				$obj2->addKataoOrder($obj1);
			}


				// Add objects for joined KataoPeriod rows
	
			$omClass = KataoPeriodPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj3 = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getKataoPeriod(); // CHECKME
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addKataoOrder($obj1); // CHECKME
					break;
				}
			}

			if ($newObject) {
				$obj3->initKataoOrders();
				$obj3->addKataoOrder($obj1);
			}


				// Add objects for joined KataoNode rows
	
			$omClass = KataoNodePeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj4 = new $cls();
			$obj4->hydrate($rs, $startcol4);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj4 = $temp_obj1->getKataoNode(); // CHECKME
				if ($temp_obj4->getPrimaryKey() === $obj4->getPrimaryKey()) {
					$newObject = false;
					$temp_obj4->addKataoOrder($obj1); // CHECKME
					break;
				}
			}

			if ($newObject) {
				$obj4->initKataoOrders();
				$obj4->addKataoOrder($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Returns the number of rows matching criteria, joining the related KataoSupplier table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinAllExceptKataoSupplier(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoOrderPeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$criteria->addJoin(KataoOrderPeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$rs = KataoOrderPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Returns the number of rows matching criteria, joining the related KataoPeriod table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinAllExceptKataoPeriod(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoOrderPeer::KATAO_SUPPLIER_ID, KataoSupplierPeer::ID);

		$criteria->addJoin(KataoOrderPeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$rs = KataoOrderPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Returns the number of rows matching criteria, joining the related KataoNode table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinAllExceptKataoNode(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoOrderPeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoOrderPeer::KATAO_SUPPLIER_ID, KataoSupplierPeer::ID);

		$criteria->addJoin(KataoOrderPeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$rs = KataoOrderPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Selects a collection of KataoOrder objects pre-filled with all related objects except KataoSupplier.
	 *
	 * @return     array Array of KataoOrder objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptKataoSupplier(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoOrderPeer:doSelectJoinAllExcept:doSelectJoinAllExcept') as $callable)
    {
      call_user_func($callable, 'BaseKataoOrderPeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoOrderPeer::addSelectColumns($c);
		$startcol2 = (KataoOrderPeer::NUM_COLUMNS - KataoOrderPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		KataoPeriodPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + KataoPeriodPeer::NUM_COLUMNS;

		KataoNodePeer::addSelectColumns($c);
		$startcol4 = $startcol3 + KataoNodePeer::NUM_COLUMNS;

		$c->addJoin(KataoOrderPeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$c->addJoin(KataoOrderPeer::KATAO_NODE_ID, KataoNodePeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoOrderPeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoPeriodPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getKataoPeriod(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addKataoOrder($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initKataoOrders();
				$obj2->addKataoOrder($obj1);
			}

			$omClass = KataoNodePeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getKataoNode(); //CHECKME
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addKataoOrder($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initKataoOrders();
				$obj3->addKataoOrder($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Selects a collection of KataoOrder objects pre-filled with all related objects except KataoPeriod.
	 *
	 * @return     array Array of KataoOrder objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptKataoPeriod(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoOrderPeer:doSelectJoinAllExcept:doSelectJoinAllExcept') as $callable)
    {
      call_user_func($callable, 'BaseKataoOrderPeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoOrderPeer::addSelectColumns($c);
		$startcol2 = (KataoOrderPeer::NUM_COLUMNS - KataoOrderPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		KataoSupplierPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + KataoSupplierPeer::NUM_COLUMNS;

		KataoNodePeer::addSelectColumns($c);
		$startcol4 = $startcol3 + KataoNodePeer::NUM_COLUMNS;

		$c->addJoin(KataoOrderPeer::KATAO_SUPPLIER_ID, KataoSupplierPeer::ID);

		$c->addJoin(KataoOrderPeer::KATAO_NODE_ID, KataoNodePeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoOrderPeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoSupplierPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getKataoSupplier(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addKataoOrder($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initKataoOrders();
				$obj2->addKataoOrder($obj1);
			}

			$omClass = KataoNodePeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getKataoNode(); //CHECKME
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addKataoOrder($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initKataoOrders();
				$obj3->addKataoOrder($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Selects a collection of KataoOrder objects pre-filled with all related objects except KataoNode.
	 *
	 * @return     array Array of KataoOrder objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptKataoNode(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoOrderPeer:doSelectJoinAllExcept:doSelectJoinAllExcept') as $callable)
    {
      call_user_func($callable, 'BaseKataoOrderPeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoOrderPeer::addSelectColumns($c);
		$startcol2 = (KataoOrderPeer::NUM_COLUMNS - KataoOrderPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		KataoSupplierPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + KataoSupplierPeer::NUM_COLUMNS;

		KataoPeriodPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + KataoPeriodPeer::NUM_COLUMNS;

		$c->addJoin(KataoOrderPeer::KATAO_SUPPLIER_ID, KataoSupplierPeer::ID);

		$c->addJoin(KataoOrderPeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoOrderPeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoSupplierPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getKataoSupplier(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addKataoOrder($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initKataoOrders();
				$obj2->addKataoOrder($obj1);
			}

			$omClass = KataoPeriodPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getKataoPeriod(); //CHECKME
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addKataoOrder($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initKataoOrders();
				$obj3->addKataoOrder($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


  static public function getUniqueColumnNames()
  {
    return array();
  }
	/**
	 * Returns the TableMap related to this peer.
	 * This method is not needed for general use but a specific application could have a need.
	 * @return     TableMap
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	/**
	 * The class that the Peer will make instances of.
	 *
	 * This uses a dot-path notation which is tranalted into a path
	 * relative to a location on the PHP include_path.
	 * (e.g. path.to.MyClass -> 'path/to/MyClass.php')
	 *
	 * @return     string path.to.ClassName
	 */
	public static function getOMClass()
	{
		return KataoOrderPeer::CLASS_DEFAULT;
	}

	/**
	 * Method perform an INSERT on the database, given a KataoOrder or Criteria object.
	 *
	 * @param      mixed $values Criteria or KataoOrder object containing data that is used to create the INSERT statement.
	 * @param      Connection $con the connection to use
	 * @return     mixed The new primary key.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doInsert($values, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoOrderPeer:doInsert:pre') as $callable)
    {
      $ret = call_user_func($callable, 'BaseKataoOrderPeer', $values, $con);
      if (false !== $ret)
      {
        return $ret;
      }
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; // rename for clarity
		} else {
			$criteria = $values->buildCriteria(); // build Criteria from KataoOrder object
		}

		$criteria->remove(KataoOrderPeer::ID); // remove pkey col since this table uses auto-increment


		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);

		try {
			// use transaction because $criteria could contain info
			// for more than one table (I guess, conceivably)
			$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}

		
    foreach (sfMixer::getCallables('BaseKataoOrderPeer:doInsert:post') as $callable)
    {
      call_user_func($callable, 'BaseKataoOrderPeer', $values, $con, $pk);
    }

    return $pk;
	}

	/**
	 * Method perform an UPDATE on the database, given a KataoOrder or Criteria object.
	 *
	 * @param      mixed $values Criteria or KataoOrder object containing data that is used to create the UPDATE statement.
	 * @param      Connection $con The connection to use (specify Connection object to exert more control over transactions).
	 * @return     int The number of affected rows (if supported by underlying database driver).
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doUpdate($values, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoOrderPeer:doUpdate:pre') as $callable)
    {
      $ret = call_user_func($callable, 'BaseKataoOrderPeer', $values, $con);
      if (false !== $ret)
      {
        return $ret;
      }
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; // rename for clarity

			$comparison = $criteria->getComparison(KataoOrderPeer::ID);
			$selectCriteria->add(KataoOrderPeer::ID, $criteria->remove(KataoOrderPeer::ID), $comparison);

		} else { // $values is KataoOrder object
			$criteria = $values->buildCriteria(); // gets full criteria
			$selectCriteria = $values->buildPkeyCriteria(); // gets criteria w/ primary key(s)
		}

		// set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);

		$ret = BasePeer::doUpdate($selectCriteria, $criteria, $con);
	

    foreach (sfMixer::getCallables('BaseKataoOrderPeer:doUpdate:post') as $callable)
    {
      call_user_func($callable, 'BaseKataoOrderPeer', $values, $con, $ret);
    }

    return $ret;
  }

	/**
	 * Method to DELETE all rows from the katao_order table.
	 *
	 * @return     int The number of affected rows (if supported by underlying database driver).
	 */
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		$affectedRows = 0; // initialize var to track total num of affected rows
		try {
			// use transaction because $criteria could contain info
			// for more than one table or we could emulating ON DELETE CASCADE, etc.
			$con->begin();
			$affectedRows += BasePeer::doDeleteAll(KataoOrderPeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Method perform a DELETE on the database, given a KataoOrder or Criteria object OR a primary key value.
	 *
	 * @param      mixed $values Criteria or KataoOrder object or primary key or array of primary keys
	 *              which is used to create the DELETE statement
	 * @param      Connection $con the connection to use
	 * @return     int 	The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
	 *				if supported by native driver or if emulated using Propel.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	 public static function doDelete($values, $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(KataoOrderPeer::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; // rename for clarity
		} elseif ($values instanceof KataoOrder) {

			$criteria = $values->buildPkeyCriteria();
		} else {
			// it must be the primary key
			$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(KataoOrderPeer::ID, (array) $values, Criteria::IN);
		}

		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; // initialize var to track total num of affected rows

		try {
			// use transaction because $criteria could contain info
			// for more than one table or we could emulating ON DELETE CASCADE, etc.
			$con->begin();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Validates all modified columns of given KataoOrder object.
	 * If parameter $columns is either a single column name or an array of column names
	 * than only those columns are validated.
	 *
	 * NOTICE: This does not apply to primary or foreign keys for now.
	 *
	 * @param      KataoOrder $obj The object to validate.
	 * @param      mixed $cols Column name or array of column names.
	 *
	 * @return     mixed TRUE if all columns are valid or the error message of the first invalid column.
	 */
	public static function doValidate(KataoOrder $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(KataoOrderPeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(KataoOrderPeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(KataoOrderPeer::DATABASE_NAME, KataoOrderPeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = KataoOrderPeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	/**
	 * Retrieve a single object by pkey.
	 *
	 * @param      mixed $pk the primary key.
	 * @param      Connection $con the connection to use
	 * @return     KataoOrder
	 */
	public static function retrieveByPK($pk, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$criteria = new Criteria(KataoOrderPeer::DATABASE_NAME);

		$criteria->add(KataoOrderPeer::ID, $pk);


		$v = KataoOrderPeer::doSelect($criteria, $con);

		return !empty($v) > 0 ? $v[0] : null;
	}

	/**
	 * Retrieve multiple objects by pkey.
	 *
	 * @param      array $pks List of primary keys
	 * @param      Connection $con the connection to use
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(KataoOrderPeer::ID, $pks, Criteria::IN);
			$objs = KataoOrderPeer::doSelect($criteria, $con);
		}
		return $objs;
	}

} // BaseKataoOrderPeer

// static code to register the map builder for this Peer with the main Propel class
if (Propel::isInit()) {
	// the MapBuilder classes register themselves with Propel during initialization
	// so we need to load them here.
	try {
		BaseKataoOrderPeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log('Could not initialize Peer: ' . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
	// even if Propel is not yet initialized, the map builder class can be registered
	// now and then it will be loaded when Propel initializes.
	Propel::registerMapBuilder('lib.model.map.KataoOrderMapBuilder');
}
